--[[
  AVCHD 対応 Bravia 用スクリプト

  ＊まだ未テストです。情報をお待ちしています。
  　GetTranscodeCommand は BRAVIA-KDL-JP1 のままです。
]]


-- この機種がサポートしているメディア情報のリスト
SUPPORT_MEDIA_LIST = {
  "image/jpeg:DLNA.ORG_PN=JPEG_SM",
  "image/jpeg:DLNA.ORG_PN=JPEG_MED",
  "image/jpeg:DLNA.ORG_PN=JPEG_LRG",
  "audio/mpeg:DLNA.ORG_PN=MP3",
  "audio/L16:DLNA.ORG_PN=LPCM",
  "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_JP_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_60_L2_T;SONY.COM_PN=HD2_60_T",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;SONY.COM_PN=HD2_60_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_60_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_60_L2_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_60_AC3_T",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_60_AC3_ISO;SONY.COM_PN=AVC_TS_HD_60_AC3_ISO",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_50_AC3_ISO;SONY.COM_PN=AVC_TS_HD_50_AC3_ISO",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_24_AC3_ISO;SONY.COM_PN=AVC_TS_HD_24_AC3_ISO",
  "video/x-mp2t-mphl-188:*"
}


--[[
 GetMimeType 関数

 メディアファイルに応じたメディア情報を返す。

 引数：
   fname: ファイル名
   minfo: MediaInfo.dll などから得られた情報
]]
function GetMimeType(fname, minfo)
  
  if minfo.General.Format == "" then return "" end
  
  if minfo.General.Format == "NowRecording" then
    -- 録画中のファイルは MPEG-TS と仮定する。
    return "video/mpeg:"
           .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;"
           .."SONY.COM_PN=HD2_60_ISO;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  end

  local ext = string.lower(string.match(fname, "%.(.-)$"))

  if ext == "jpg" then
    return "image/jpeg:DLNA.ORG_PN=JPEG_LRG;"
     .."DLNA.ORG_FLAGS=8cf00000000000000000000000000000"
  end

  if ext == "mp3" then
    return "audio/mpeg:DLNA.ORG_PN=MP3;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000"
  end
  
  if ext == "wav" then
    return "audio/L16:DLNA.ORG_PN=LPCM;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000"
  end
  
  if minfo.Video.Format == "" then return "" end
  
  local res = "video/x-mp2t-mphl-188:*;DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  local fr = string.sub(minfo.Video.FrameRate, 1, 2)

  if (minfo.Video.Format == "AVC") and (minfo.General.Format == "MPEG-TS") then
    if fr == "23" then
      fr = "24"
    elseif (fr == "29") or (fr == "59") or (minfo.Video.Standard == "NTSC") then
      fr = "60"
    elseif (fr == "25") or (minfo.Video.Standard == "PAL") then
      fr = "50"
    end
    return "video/mpeg:"
     .."DLNA.ORG_PN=AVC_TS_HD_"..fr.."_AC3_ISO;"
     .."SONY.COM_PN=AVC_TS_HD_"..fr.."_AC3_ISO;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
     .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  end

  if minfo.Video.Format == "MPEG Video" then
    if minfo.General.Format == "BDAV" then
      -- NTSC?
      if (fr == "29") or (fr == "59") or (minfo.Video.Standard == "NTSC") then
        res = "video/vnd.dlna.mpeg-tts:"
         .."DLNA.ORG_PN=MPEG_TS_JP_T;"
         .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
         .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"

        -- HD?
        if tonumber(minfo.Video.Width) > 1000 then
          -- AVCHD?
          if minfo.Video.Format == "AVC" and minfo.Audio.Format == "AC-3" then
          
            -- まだ未テストです。情報をお待ちしています。
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=DLNA.ORG_PN=AVC_TS_HD_60_AC3_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"

          elseif minfo.Audio.Format == "AAC" then
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_T;"
             .."SONY.COM_PN=HD2_60_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          end
        else
          -- AC3?
          if minfo.Audio.Format == "AC-3" then
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=MPEG_TS_SD_60_AC3_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          else
            -- AAC etc.
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=MPEG_TS_SD_60_L2_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          end
        end
      end
      return res
    elseif minfo.General.Format == "MPEG-TS" then
      -- NTSC?
      if (fr == "29") or (fr == "59") or (minfo.Video.Standard == "NTSC") then
        -- HD?
        if tonumber(minfo.Video.Width) > 1000 then
          res = "video/mpeg:"
           .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;"
           .."SONY.COM_PN=HD2_60_ISO;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
        end
      end
      return res
    end
  end

  if minfo.General.Format == "MPEG-PS"
    -- NTSC?
    and ((fr == "29") or (fr == "59") or (minfo.Video.Standard == "NTSC"))
    -- SD?
    and tonumber(minfo.Video.Width) < 1000
    -- アスペクト比=16/9 ?
    and minfo.Video.DisplayAspectRatio == "1.778" then

    res = "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
     .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"

  else

    res = "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
     .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
     ..":::TRANS:::" -- トランスコードが必要なことをBMSに伝える

  end

  return res
end


--[[
 GetTranscodeCommand 関数
 
 トランスコードのコマンドを返す。

 引数：
   fname: ファイル名
   minfo: MediaInfo.dll などから得られた情報
]]
function GetTranscodeCommand(fname, minfo)

  local aspect = minfo.Video.DisplayAspectRatio
  if aspect == "" then aspect = "1.333" end
  --print("\r\nDEBUG: "..fname.." aspect="..aspect.."\r\n")
  local w = minfo.Video.Width
  local h = minfo.Video.Height

  -- この機種ではHDサイズのものは正しく表示されない場合があるよう
  -- なのでSDサイズに変換する。
  if tonumber(w) > 720 then
    w = "720" h = "480"
  end
  -- この機種ではアスペクト比16/9以外のものに未対応のようなので
  -- アスペクト比16/9以外のものは16/9に変換する。
  local vfs = "scale="..w..":"..h..","
  if aspect ~= "1.778" then
    local sw = w
    local sh = h
    if tonumber(aspect) < 1.778 then
      sw = math.floor(w / 1.778 * aspect + 0.5)
    else
      sh = math.floor(h * 1.778 / aspect + 0.5)
    end
    vfs = "scale="..sw..":"..sh..",expand="..w..":"..h..","
    aspect = "1.778"
  end
  
  if minfo.General.Format == "ISO DVD" then

    if minfo.DVD.ALANG.en and minfo.DVD.SLANG.ja then

      -- 英語音声と日本語字幕がある場合

      return [[

       [$_name_$ (英語音声・日本語字幕)]
       mencoder -dvd-device "$_in_$" dvd://$_longest_$
       -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
       -vf ]]..vfs..[[harddup -srate 48000 -af lavcresample=48000
       -ofps 30000/1001 -alang en -slang ja -channels 6
       -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
       ..aspect

      ..[[

       [$_name_$ (日本語音声)]
       mencoder -dvd-device "$_in_$" dvd://$_longest_$
       -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
       -vf ]]..vfs..[[harddup -srate 48000 -af lavcresample=48000
       -ofps 30000/1001 -alang ja -slang ja -forcedsubsonly -channels 6
       -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
       ..aspect
       
      ..[[

       [$_name_$ (英語音声)]
       mencoder -dvd-device "$_in_$" dvd://$_longest_$
       -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
       -vf ]]..vfs..[[harddup -srate 48000 -af lavcresample=48000
       -ofps 30000/1001 -alang en -slang en -forcedsubsonly -channels 6
       -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
       ..aspect
       
    else

      return [[

       [$_name_$]
       mencoder -dvd-device "$_in_$" dvd://$_longest_$
       -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
       -vf ]]..vfs..[[harddup -srate 48000 -af lavcresample=48000
       -ofps 30000/1001 -forcedsubsonly -channels 6
       -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
       ..aspect

    end

  else

    return [[

     [$_name_$ (TRANSCODE to MPEG-PS)]
     mencoder "$_in_$"
     -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
     -vf ]]..vfs..[[harddup -srate 48000 -af lavcresample=48000
     -ofps 30000/1001 -channels 6
     -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
     ..aspect

  end
end
